# Selfhost of Services

Hosting the following web services using docker-compose on a public root server:

* [Nextcloud](https://nextcloud.com/)
* [Gitea](https://gitea.io/)
* [Wallabag](https://www.wallabag.it)
* Small HTML-Site
* Firefox-Sync
* Monitoring-Stack with [Telegraf](https://github.com/influxdata/telegraf), [Influxdb](https://github.com/influxdata/influxdb) and [Grafana](https://github.com/grafana/grafana)

As a reverse proxyy [Traefik](https://traefik.io/traefik/) is used. Traefik also secures all Services with TLS and redirects all HTTP requests to HTTPS. SSL certificates are automatically generated using [Let's Encrypt](https://letsencrypt.org/)

## How to deploy
1. [Install Docker](https://docs.docker.com/engine/install/debian/)
2. [Install Docker Compose v2 Plugin](https://docs.docker.com/compose/install/linux/)
3. Clone this repository
4. create *.env* file in each folder and set environment variables.  
   Example:
   ~~~
   DOMAIN=example.com
   TRAEFIK_VERSION=2.4
   ~~~
5. run *pull-all.sh" and *start-all.sh" scripts

## Links: 
* [Nextcloud docker](https://github.com/nextcloud/docker/)
* [Gitea Doku: Install with Docker](https://docs.gitea.io/en-us/install-with-docker/)
* [Docker Swarm Rocks](https://dockerswarm.rocks/)
* [Mozilla Services Documentation](https://mozilla-services.readthedocs.io/en/latest/index.html)
* [Docker Compose](https://docs.docker.com/compose/)
* [Docker Compose File Specification/Reference](https://docs.docker.com/compose/compose-file/)
